SystemOrganization addCategory: #'Spec-Tests'!

ComposableModel subclass: #TestingComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!TestingComposableModel commentStamp: '<historical>' prior: 0!
A TestingComposableModel is a stupid composable model used to test SpecInterpreter!

!TestingComposableModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:35'!
defaultSpec
	<spec>
	^ {#List.
		#model:.	#model}.! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 5/22/2012 15:05'!
testingSpec

	^ {#Text.
		#model:.	#model}.! !

!TestingComposableModel class methodsFor: 'specs' stamp: ''!
title

	^ 'You should not see me !!'! !

TestCase subclass: #SpecInterpreterTest
	instanceVariableNames: 'specInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!SpecInterpreterTest commentStamp: '<historical>' prior: 0!
A SpecInterpreterTest is a test class for testing the behavior of SpecInterpreter!

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/26/2012 12:56'!
setUp
	"Setting up code for SpecInterpreterTest"


	specInterpreter := SpecInterpreter new.
	specInterpreter model: TestingComposableModel new! !

!SpecInterpreterTest methodsFor: 'initialization' stamp: ''!
tearDown
	"Tearing down code for SpecInterpreterTest"


	specInterpreter := nil.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/17/2012 17:57'!
testBuildMorphFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model.
	
	self assert: (morph model == model).
	self assert: (model widget class = PluggableListMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/17/2012 17:57'!
testBuildMorphForWithSpec

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model widget class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 5/22/2012 14:57'!
testBuildWindowFor

	| model widget |
	model := TestingComposableModel new.
	widget := specInterpreter buildWindowFor: model.
	
	self assert: ( model widget = widget).
	self assert: (widget submorphs anySatisfy: [:e | e class = PluggableListMorph ])! !

!SpecInterpreterTest methodsFor: 'tests' stamp: ''!
testConvertRandomSymbolOfClassToInstance
	
	| symbol instance |
	symbol := #PluggableListMorph.
	
	instance := specInterpreter convertSymbolOfClassToInstance: symbol.
	self assert: (instance class name = symbol)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/17/2012 17:57'!
testInterpretASpecModelMorphAssociation

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (model widget == morph).! !
